/*
 * OpenCL Info
 * Copyright (C) 2009 cmf
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __MAIN_H__
#define __MAIN_H__

#define __CL_ENABLE_EXCEPTIONS

#include <iostream>
#include <OpenCL/OpenCL.h>
#include <OpenGL/OpenGL.h>
#include "cl.hpp"
#include "ogl.h"

#define OCLINFO_MAJOR_VERSION 0
#define OCLINFO_MINOR_VERSION 2
#define OCLINFO_BUILD_TIME __TIME__
#define OCLINFO_BUILD_DATE __DATE__

#define TAB "\t"

using namespace std;

cl::Context* context;
cl::Platform* platform;
vector<cl::Device> devices;
vector<cl::Platform> platforms;
unsigned int cpu_memory = 0;

void init_platform();
void init(bool ogl_sharing);

#endif
