/*
 * OpenCL Info
 * Copyright (C) 2009 cmf
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#import "ogl.h"
#import <Cocoa/Cocoa.h>

NSOpenGLContext* ogl_context;
CGLContextObj cgl_context;

void create_ogl_context() {
    NSAutoreleasePool* pool = [[NSAutoreleasePool alloc] init];
	
	NSOpenGLPixelFormatAttribute attributes[] = {
		NSOpenGLPFAColorSize, 32,
		NSOpenGLPFAAccelerated,
		NSOpenGLPFAScreenMask, CGDisplayIDToOpenGLDisplayMask(CGMainDisplayID()),
		0
	};
	
	NSOpenGLContext* ctx = nil;
	NSOpenGLPixelFormat* px_format = [[NSOpenGLPixelFormat alloc] initWithAttributes:attributes];
	if(px_format != nil) {
		ctx = [[NSOpenGLContext alloc] initWithFormat:px_format shareContext:nil];
	}
	[px_format release];
	
	ogl_context = ctx;
	cgl_context = (CGLContextObj)[ogl_context CGLContextObj];
	
	[ogl_context makeCurrentContext];
	
	[pool release];
}

void destroy_ogl_context() {
	[NSOpenGLContext clearCurrentContext];
	[ogl_context clearDrawable];
	[ogl_context release];
	
	ogl_context = NULL;
}
